package tools.descartes.prisma.agent.wildfly.callstack;

import java.util.Collection;
import java.util.Collections;

import tools.descartes.prisma.agent.wildfly.parameters.ValueCharacterization;

public abstract class OperationRecord {

	private final TraceFactory factory;
	private final InterfaceRecord interf;
	private final String operation;
		
	public OperationRecord(InterfaceRecord interf, String operation) {
		this.factory = interf.getTraceFactory();
		this.interf = interf;
		this.operation = operation;		
	}
	
	public InterfaceRecord getInterface() {
		return interf;
	}

	public String getOperationName() {
		return operation;
	}
	
	public TraceFactory getTraceFactory() {
		return factory;
	}
	
	public String[] getObservedParameterNames() {
		return new String[0];
	}
	
	public int[] getObservedParameterIndeces() {
		return new int[0];
	}
	
	public int characterizeValue(int param, Object value) {
		return 0;
	}
	
	public abstract InvocationGroupRecord requireInvocationGroup(int idx);
	
	public InvocationGroupRecord[] getInvocationGroups() {
		return new InvocationGroupRecord[0];
	}
	
	public abstract boolean isFiltered();
	
	public abstract void accept(TraceVisitor visitor, InvocationGroupRecord source);

}
